Subject: Re: Re: linux-next: build failure after merge of the pm tree

From: Krzysztof Kozlowski <[email-masked]>
Date: Mon, 19 Sep 2016 18:12:18 +0200

On Mon, Sep 19, 2016 at 07:37:24AM +0000, MyungJoo Ham wrote:
> > On Wednesday, September 14, 2016 02:27:47 PM Stephen Rothwell wrote:
> > > Hi Rafael,
> > > 
> > > After merging the pm tree, today's linux-next build (powerpc allyesconfig)
> > > failed like this:
> > > 
> > > drivers/devfreq/tegra-devfreq.c: In function 'tegra_devfreq_target':
> > > drivers/devfreq/tegra-devfreq.c:500:2: error: implicit declaration of function 'clk_set_min_rate' [-Werror=implicit-function-declaration]
> > >   clk_set_min_rate(tegra->emc_clock, rate);
> > >   ^
> > > 
> > > Caused by commit
> > > 
> > >   797da5598f3a ("PM / devfreq: Add COMPILE_TEST for build coverage")
> 
> @Rafael: Thank you!
> 
> 
> @Kozlowski:
> 
> It looks like COMMON_CLK is required to be "selected" for TEGRA.
> 
> Although COMMON_CLK is supposed to be widely used by most ARM platforms
> especially if "Multiple platfrom selection" for ARMv7 is used,
> COMPILE_TEST won't recognize it.
> 
> Adding COMMON_CLK for TEGRA will solve this instance of issue; however,
> for COMPILE_TEST to be reasonably robust, each "COMPILE_TEST"ed item
> should "select" every required item. How do you want to proceed with
> COMPILE_TEST on SoC-specific device drivers?

I think drivers should depend on COMMON_CLK in such case. This tegra
driver probably does not require strict ARCH_TEGRA_124_SOC dependency
because it does not use any SoC-specific data/functions etc. However it
uses common clock framework so explicit dependency looks proper to me.

In fact this is already seen in kernel like SND_SOC_TEGRA, SND_MXS_SOC,
PWM_IMG(with compile test), SND_SOC_RCAR (even without compile test).

Best regards,
Krzysztof